# Enterprise SMART Matrix - GunDB Server for HTTP(s)

A GunDB server to use in syncronization scenarios for GunDB.

![Logo of the project](/public/img/logo.png)

As technology continues to shift and grow, a gap continues to emerge in how Enterprises can leverage a community of experienced and skilled developers.  More important, is how to leverage this community in a scalable and secure way that enables both sides to thrive in the delivery of business-critical solutions and products.

The Enterprise SMART Matrix Schema supports a configuration driven development experience that separates developers from the technology infrastructure configured by enterprise engineers.  This enables developers to create solutions against an application spec that enterprise managers can configure to their platform.

## Installing / Getting started

This repository contains the Enterprise SMART Matrix GunDB server instance.  To get started install the package:

```shell
npm install @smart-matrix/gundb-server-http
```

* This will install the package locally to your system for consumption in your project.

### TypeScript Quick Start

Information about using the Type Script Definition

### Typescript with Protocol Buffers Quick Start

Information about using the Proto Buffer Definition

#### Using Protocol Buffers Definitions

TODO: Docs

## Features

What's all the bells and whistles this project can perform?

* What's the main functionality
* You can also do another thing
* If you get really randy, you can even do this

## Developing

Getting started with development on this project is straight forward...

```shell
git clone https://github.com/your/awesome-project.git
cd awesome-project/
npm install
```

And state what happens step-by-step...

### Building

If your project needs some additional steps for the developer to build the
project after some code changes, state them here:

```shell
./configure
make
make install
```

Here again you should state what actually happens when the code above gets
executed.

### Deploying / Publishing

In case there's some step you have to take that publishes this project to a
server, this is the right time to state it.

```shell
packagemanager deploy awesome-project -s server.com -u username -p password
```

And again you'd need to tell what the previous code actually does.

## Configuration

Here you should write what are all of the configurations a user can enter when
using the project.

### Argument 1

Type: `String`  
Default: `'default value'`

State what an argument does and how you can use it. If needed, you can provide
an example below.

Example:

```bash
awesome-project "Some other value"  # Prints "You're nailing this readme!"
```

### Argument 2

Type: `Number|Boolean`  
Default: 100

Copy-paste as many of these as you need.

## Contributing

When you publish something open source, one of the greatest motivations is that
anyone can just jump in and start contributing to your project.

These paragraphs are meant to welcome those kind souls to feel that they are
needed. You should state something like:

"If you'd like to contribute, please fork the repository and use a feature
branch. Pull requests are warmly welcome."

If there's anything else the developer needs to know (e.g. the code style
guide), you should link it here. If there's a lot of things to take into
consideration, it is common to separate this section to its own file called
`CONTRIBUTING.md` (or similar). If so, you should say that it exists here.

## Links

Even though this information can be found inside the project on machine-readable
format like in a .json file, it's good to include a summary of most useful
links to humans using your project. You can include links like:

* Project homepage: <https://your.github.com/awesome-project/>
* Repository: <https://github.com/your/awesome-project/>
* Issue tracker: <https://github.com/your/awesome-project/issues>
  * In case of sensitive bugs like security vulnerabilities, please contact
    my@email.com directly instead of using issue tracker. We value your effort
    to improve the security and privacy of this project!
* Related projects:
  * Your other project: <https://github.com/your/other-project/>
  * Someone else's project: <https://github.com/someones/awesome-project/>

## Licensing

The code in this project is licensed:

[Project License](/LICENSE)
